#pragma once
#include <memory>
#include <iostream>
#include <vector>
#include <unordered_map>
#include "../Scene/Mesh.h"
#include "../Scene/cube.h"


#include "Texture.h"
#include <glm/gtc/matrix_transform.hpp>

namespace Inbetween {
	namespace Ressources {
		class LoadRessources
		{
		public:
			LoadRessources();
			~LoadRessources();
			
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollisionloadLevel01();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollisionloadLevel02();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollisionloadLevel03();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollisionloadLevel04();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollisionloadLevel05();

			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadLevel01();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadLevel02();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadLevel03();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadLevel04();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadLevel05();

			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadindependentMesh();

			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollectibles01();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollectibles02();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollectibles03();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadCollectibles04();

			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadEnemies01();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadEnemies02();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadEnemies03();
			std::unordered_map<std::string, std::unique_ptr<scene::Mesh>> loadEnemies04();



			std::unordered_map<std::string, std::unique_ptr<Texture>> loadTexture();
			std::unordered_map<std::string, std::unique_ptr<Shader>> loadShader();

		//	void changeShader(Mesh* mesh, std::unique_ptr<Shader> shader);
		};
	}
}

