#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec3 fragNormal;
out vec2 fragmentUV;
out vec3 fragPos;
out vec4 FragPosLightSpace;


uniform mat4 model;
uniform mat4 VP;
uniform mat4 lightSpaceMatrix;


void main()
{
	fragmentUV = uv;
	fragNormal = (model * vec4(normal, 0)).xyz;
	//fragNormal = transpose(inverse(mat3(model))) * normal;
	fragPos = vec3(model * vec4(position, 1.0f));
	FragPosLightSpace = lightSpaceMatrix * vec4(fragPos, 1.0);
	gl_Position = VP * model * vec4(position, 1.0f);
}