
#version 330 core
out vec4 FragColor;

in vec2 fragmentUV;

uniform sampler2D hdrBuffer;
uniform sampler2D bloomBlur;
uniform bool hdr;
uniform float exposure;
uniform bool bloom;

void main()
{             
    const float gamma = 2.2;
    vec3 hdrColor = texture(hdrBuffer, fragmentUV).rgb;
	vec3 bloomColor = texture(bloomBlur, fragmentUV).rgb;
    if(bloom){
        hdrColor += bloomColor;
    }
    if(hdr)
    {        
        // reinhard
        // vec3 result = hdrColor / (hdrColor + vec3(1.0));
        // exposure
        vec3 result = vec3(1.0) - exp(-hdrColor * exposure);
        // also gamma correct while we're at it       
        //result = pow(result, vec3(1.0 / gamma));
        FragColor = vec4(result, 1.0);
    }
    else
    {
        vec3 result = pow(hdrColor, vec3(1.0 / gamma));
        FragColor = vec4(result, 1.0);
    }
}